# Rules.make for uClibc apps.

#include $(UCLIBC_DIR)/.config

INSTALL_PATH = $(CRAMFS_DIR)
INSTALL_PATH_BIN = $(INSTALL_PATH)/bin

DESTDIR = $(CRAMFS_DIR)
BINDIR = $(DESTDIR)/bin

# Use NATIVE_ARCH here since running these test is not
# even possible when cross compiling...
NATIVE_ARCH:= ${shell uname -m | sed \
		-e 's/i.86/i386/' \
		-e 's/sparc.*/sparc/' \
		-e 's/arm.*/arm/g' \
		-e 's/m68k.*/m68k/' \
		-e 's/ppc/powerpc/g' \
		-e 's/v850.*/v850/g' \
		-e 's/sh[234].*/sh/' \
		-e 's/mips.*/mips/' \
		}
ifeq ($(strip $(TARGET_ARCH)),)
TARGET_ARCH_X :=${shell $(CC) -dumpmachine | sed -e s'/-.*//' \
		-e 's/i.86/i386/' \
		-e 's/sparc.*/sparc/' \
		-e 's/arm.*/arm/g' \
		-e 's/m68k.*/m68k/' \
		-e 's/ppc/powerpc/g' \
		-e 's/v850.*/v850/g' \
		-e 's/sh[234]/sh/' \
		-e 's/mips.*/mips/' \
		}
endif

# Cross-tools
CC        = arm-elf-gcc
LD        = arm-elf-ld
AR        = arm-elf-ar
RANLIB    = arm-elf-ranlib
STRIPTOOL = arm-elf-strip

# Host tools
HOST_CC = gcc

# Check if 'ls -sh' works or not
LSFLAGS = -l

# turn all the warnings on
WARNINGS=

# use '-Os' optimization if available, else use -O2
OPTIMIZATION = ${shell if $(CC) -Os -S -o /dev/null -xc /dev/null >/dev/null 2>&1; \
    then echo "-Os"; else echo "-O2" ; fi}

ifeq ($(DODEBUG),true)
    CFLAGS +=$(WARNINGS) $(OPTIMIZATION) -g
    STRIPTOOL =/bin/true -Since_we_are_debugging
else
    CFLAGS  +=$(WARNINGS) $(OPTIMIZATION) -fomit-frame-pointer
    STRIP   = $(STRIPTOOL) --remove-section=.note --remove-section=.comment $(PROG)
endif

CFLAGS += -nostdinc -isystem $(DEVEL_DIR)/include -iwithprefix include
CFLAGS += -D__uClinux__
CFLAGS += -D__PIC__ -fpic -msingle-pic-base -msoft-float -mstructure-size-boundary=8 -fno-strict-aliasing

LDFLAGS += -Wl,-warn-common
LDFLAGS += -static -s -fpic -msingle-pic-base -msoft-float
#LDFLAGS += -nostartfiles -L$(DEVEL_DIR)/lib $(DEVEL_DIR)/lib/crt0.o
LDFLAGS += -Wl,-elf2flt

FLTFLAGS += -r -s 20000
export FLTFLAGS
